//editor.c
//contains the editor code

//allegro include
#include <allegro.h>

//external include
#include "external.h"
#include "copyright.h"

//variables
int exitf; //the exit flag
BITMAP *screenbuff; //the screen buffer
int bbp; //tells how many bits per pixel in the current screen mode
         //hmm should be bpp... oh well.

//several various variables that tells currently selected stuff
unsigned char curblock = 0, curstructure = 0, curmap = 0, curtile = 0,
 cursprite = 0, spritemode = 0, command = 0, level = 0;

//several various offset variables
int dataoffset = 0, chroffset = 0, palletenumber = 0;

//all the bitmaps
BITMAP *tile[4][256];
BITMAP *levelpal;
BITMAP *block[256];
BITMAP *structure[256];
BITMAP *map[64];
BITMAP *cursor; // the mouse cursor
int x, y, i;//temp variables used kinda like registers in asm

//the mouse variables
int clicked1, clicked2;
int canclick1,canclick2;

//Functions

//This Inits the editor
void init(){
allegro_init();     //Initiliaze Allegro
set_color_depth(15);//set the color depth
bbp = 15;
if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0) < 0){
set_color_depth(16);
bbp = 16;
      if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0) < 0){
      crash(allegro_error);
      }
};//now change to graphics mode

//create and clear the bitmap that shows the pallete
levelpal = create_bitmap(16*20,4*16);
clear(levelpal);

for(i = 0;i < 256;i++){ //create and clear the tiles, blocks, and structures
tile[0][i] = create_bitmap(8,8);
clear(tile[0][i]);
tile[1][i] = create_bitmap(8,8);
clear(tile[1][i]);
tile[2][i] = create_bitmap(8,8);
clear(tile[2][i]);
tile[3][i] = create_bitmap(8,8);
clear(tile[3][i]);

block[i] = create_bitmap(16,16);
clear(block[i]);
structure[i] = create_bitmap(64,64);
clear(structure[i]);
}

for(i = 0;i < 64;i++){//and the maps.
map[i] = create_bitmap(256,256);
clear(map[i]);
}

chroffset = 0x52010;//set the chr offset
dataoffset = 0x0000;

//load the rom
if(loadrom())crash("megaman3.nes not found");

copytiles(chroffset);//Copy the tile data

//load everything
loadpallete();

filltiledata();

fillblockdata();

fillstructuredata();

fillmapdata(curmap);

fillpalletedata();

install_keyboard();//Installs the allegro keyboard handler

if (install_mouse() == -1){//Install Mouse Handler
  crash("Mouse failed to initilize.");
}
cursor = load_bitmap("cursor.pcx",NULL);//and load the cursor
if (cursor == NULL) {
  crash("cursor.pcx failed to open");
}

srandom(time(NULL));//init the random number generator

screenbuff = create_bitmap(640, 480); //init the screen buffer
clear(screenbuff); //and clear it
}

//this uninits the editor
extern void uninit(){
destroy_bitmap(screenbuff);

destroy_bitmap(levelpal);
for(i = 0;i < 256;i++){ //destroy EVERYTHING BWAHAHAHA!!!! j/k
destroy_bitmap(tile[0][i]);
destroy_bitmap(tile[1][i]);
destroy_bitmap(tile[2][i]);
destroy_bitmap(tile[3][i]);
destroy_bitmap(block[i]);
destroy_bitmap(structure[i]);
}

for(i = 0;i < 64;i++){
destroy_bitmap(map[i]);
}

set_gfx_mode(GFX_TEXT,0,0,0,0);

}

//this is the core of the editor it contains everything needed to run
extern void runeditor(){

//the very first thing we should do is detect if F1 is being pressed so we can
//bypass this whole function and show the help screen
if(key[KEY_F1]){
clear(screenbuff);
textprintf(screenbuff,font,0,0,makecol(255,255,255),"PLEASE SEE README.TXT FOR HELP");
return;
}

//this cool code makes clicked1 be set
//for only one frame whenever you click
//this is to avoid the editor thinking you are clicking over and over
//when you really click once
if((mouse_b & 1) && canclick1){clicked1 = true;canclick1 = false;}
else clicked1 = false;
if(!(mouse_b && 1)) canclick1 = true;

//this does the same for clicked2
if((mouse_b & 2) && canclick2){clicked2 = true;canclick2 = false;}
else clicked2 = false;
if(!(mouse_b && 2)) canclick2 = true;

//now heres all the clicking code
if(clicked1){
//this code selects a tile from the tile area in the upper left corner
   if((mouse_y < 129) && (mouse_x < 129)){
      curtile = ((mouse_x+1)/8)+(((mouse_y+1)/8)<<4);
   }

//this code changes a pallete entry
   if((mouse_y > 106) && (mouse_y < 106+(4*16)) &&
     (mouse_x > 290) && (mouse_x < 290+(20*16))){
      romdata[0xa92+dataoffset+
      (((mouse_x-290)/16)+(((mouse_y-106)/16)*20))]++;

      loadpallete();
      filltiledata();
      fillblockdata();
      fillstructuredata();
      fillmapdata(curmap);
      fillpalletedata();
   }

//this code selects a block from the list of blocks
   if((mouse_y > 136) && (mouse_y < 136+16)){
      if(((mouse_x/16) < 9) && (mouse_x/16 != 4)){
      curblock = curblock+((mouse_x/16)-4);
      }
   }

//this code draws a tile onto a block
  if((mouse_x-64 < 16) && (mouse_y-136 < 16) &&
  (mouse_y-136 > 0) && (mouse_x-64 > 0)){
  
  if((mouse_y-136 < 8) && (mouse_x-64 < 8))
  romdata[0x1b10+dataoffset+curblock]=curtile;

  if((mouse_y-136 < 8) && (mouse_x-64 > 8))
  romdata[0x1c10+dataoffset+curblock]=curtile;

  if((mouse_y-136 > 8) && (mouse_x-64 < 8))
  romdata[0x1d10+dataoffset+curblock]=curtile;

  if((mouse_y-136 > 8) && (mouse_x-64 > 8))
  romdata[0x1e10+dataoffset+curblock]=curtile;
  fillblockdata();
  fillstructuredata();
  fillmapdata(curmap);
  }

//this code selects a structure from the list of structures
   if((mouse_y > 160) && (mouse_y < 160+32)){
      if(((mouse_x/32) < 9) && (mouse_x/32 != 4)){
      curstructure = curstructure+((mouse_x/32)-4);
      }
   }

//this code draws a block onto a structure
  if((mouse_x-128 < 32) && (mouse_y-160 < 32) &&
  (mouse_y-160 > 0) && (mouse_x-128 > 0)){
  
  if((mouse_y-160 < 16) && (mouse_x-128 < 16))
  romdata[0x1710+dataoffset+(curstructure*4)]=curblock;

  if((mouse_y-160 < 16) && (mouse_x-128 > 16))
  romdata[0x1710+dataoffset+(curstructure*4)+1]=curblock;

  if((mouse_y-160 > 16) && (mouse_x-128 < 16))
  romdata[0x1710+dataoffset+(curstructure*4)+2]=curblock;

  if((mouse_y-160 > 16) && (mouse_x-128 > 16))
  romdata[0x1710+dataoffset+(curstructure*4)+3]=curblock;

  fillstructuredata();
  fillmapdata(curmap);
  }

//this code selects a map screen from the maps to the left and right
   if(mouse_y > 220){
   if((curmap > 0) && (mouse_x < 192))fillmapdata(--curmap);
   if((curmap < 63) && (mouse_x > 192+256))fillmapdata(++curmap);
   }

//this code draws structures to the map
   if(!spritemode){ //skip this if we are in sprite mode
   if((mouse_y > 220) && (mouse_x > 192) && (mouse_x < 192+256)){
      romdata[dataoffset+0xf10+(romdata[0xa10+dataoffset+curmap]*0x40)+
      (((mouse_y-220)/32)*8)+((mouse_x-192)/32)]
      = curstructure;
      fillmapdata(curmap);
   }}//end both ifs

//this code puts cursprite to wherever you click
   if(spritemode && (!key[KEY_INSERT])){//only do this if in sprite mode
                                        //and if we aren't inserting a sprite
   if((mouse_y >= 220) && (mouse_x >= 192) && (mouse_x < 192+256)){

   romdata[0xb10+dataoffset+cursprite] = curmap;//change the screen
   romdata[0xc10+dataoffset+cursprite] = mouse_x-184;//change the x
   romdata[0xd10+dataoffset+cursprite] = mouse_y-220;//change the y
   fillmapdata(curmap);}
   }

//this code detects if you clicked onto blockpal and changes it if so
  if((mouse_x > 232) && (mouse_x < 256) &&
    (mouse_y > 136) && (mouse_y < 144)){
   romdata[(0x1f10+dataoffset)+curblock] = (((romdata[(0x1f10+dataoffset)+curblock]&15)+1)&15)|
   (romdata[(0x1f10+dataoffset)+curblock]&0xF0);
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   }

//this code detects if you clicked onto blockdata and changes it if so
  if((mouse_x > 240) && (mouse_x < 264) &&
    (mouse_y > 144) && (mouse_y < 152)){
   romdata[(0x1f10+dataoffset)+curblock] =
   (romdata[(0x1f10+dataoffset)+curblock]+16);

   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   }

//this code detects if you clicked on the < or > of level and changes it if so
  if((mouse_y > 203) && (mouse_y < 211)){
  if((mouse_x > 396) && (mouse_x < 404))key[KEY_E] = 1;
  if((mouse_x > 564) && (mouse_x < 572))key[KEY_R] = 1;
  //lets do this the easy way and just simulate pressing left and right
  //to trigger the key code
  }

//this code detects if you clicked on the < or > of CURRENT SPRITE and changes it if so
  if((mouse_y > 56) && (mouse_y < 64)){
  if((mouse_x > 300) && (mouse_x < 308)){cursprite--; fillmapdata(curmap);}
  if((mouse_x > 468) && (mouse_x < 474)){cursprite++; fillmapdata(curmap);}
  }

//this code detects if you clicked on the < or > of SPRITE X and changes it if so
  if((mouse_y > 64) && (mouse_y < 72)){
  if((mouse_x > 300) && (mouse_x < 308)){romdata[cursprite+dataoffset+0xc10]--;
  fillmapdata(curmap);}

  if((mouse_x > 468) && (mouse_x < 474)){romdata[cursprite+dataoffset+0xc10]++;
  fillmapdata(curmap);}
  }

//this code detects if you clicked on the < or > of SPRITE Y and changes it if so
  if((mouse_y > 72) && (mouse_y < 80)){
  if((mouse_x > 300) && (mouse_x < 308)){romdata[cursprite+dataoffset+0xd10]--;
  fillmapdata(curmap);}

  if((mouse_x > 468) && (mouse_x < 474)){romdata[cursprite+dataoffset+0xd10]++;
  fillmapdata(curmap);}
  }

//this code detects if you clicked on the < or > of SPRITE SCREEN and changes it if so
  if((mouse_y > 80) && (mouse_y < 88)){
  if((mouse_x > 300) && (mouse_x < 308)){romdata[cursprite+dataoffset+0xb10]--;
  fillmapdata(curmap);}

  if((mouse_x > 468) && (mouse_x < 474)){romdata[cursprite+dataoffset+0xb10]++;
  fillmapdata(curmap);}
  }

//this code detects if you clicked on the < or > of SPRITE TYPE and changes it if so
  if((mouse_y > 88) && (mouse_y < 96)){
  if((mouse_x > 300) && (mouse_x < 308)){romdata[cursprite+dataoffset+0xe10]--;
  fillmapdata(curmap);}

  if((mouse_x > 468) && (mouse_x < 474)){romdata[cursprite+dataoffset+0xe10]++;
  fillmapdata(curmap);}
  }

//this code detects if you clicked on the < or > of map screen and changes it if so
  if((mouse_y > 211) && (mouse_y < 219)){
    if((mouse_x > 396) && (mouse_x < 404)){
    romdata[0xa10+dataoffset+curmap]-=1;
    fillmapdata(curmap);
    }

    if((mouse_x > 564) && (mouse_x < 572)){
    romdata[0xa10+dataoffset+curmap]+=1;
    fillmapdata(curmap);
    }
  }

//this code changes command if you clicked it
  if((mouse_y > 64) && (mouse_y < 72)){
    if((mouse_x > 130) && (mouse_x < 234)){
    command++;
    }
  }


//this code changes screen direction
  if((mouse_y > 72) && (mouse_y < 80)){
    if((mouse_x > 130) && (mouse_x < 280)){
    romdata[0xa50+dataoffset+command] =
    ((romdata[0xa50+dataoffset+command])&15)+
    (((romdata[0xa50+dataoffset+command]>>4)+1)<<4);
    }
  }

//this code changes screen pallete
  if((mouse_y > 80) && (mouse_y < 88)){
    if((mouse_x > 130) && (mouse_x < 264)){
    romdata[0xa70+dataoffset+(command*2)+1] =
    ((romdata[0xa70+dataoffset+(command*2)+1]+1)&3);
    }
  }

//this code changes screen chr data
  if((mouse_y > 88) && (mouse_y < 96)){
    if((mouse_x > 130) && (mouse_x < 272)){
    romdata[0xa70+dataoffset+(command*2)] =
    ((romdata[0xa70+dataoffset+(command*2)])&15)+
    (((romdata[0xa70+dataoffset+(command*2)]>>4)+1)<<4);
    }
  }

}//end if clicked1

//heres the mouse button 2 clicking code
if(clicked2){
//this code changes a pallete entry
   if((mouse_y > 106) && (mouse_y < 106+(4*16)) &&
     (mouse_x > 290) && (mouse_x < 290+(20*16))){
      romdata[0xa92+dataoffset+
      (((mouse_x-290)/16)+(((mouse_y-106)/16)*20))]--;

      loadpallete();
      filltiledata();
      fillblockdata();
      fillstructuredata();
      fillmapdata(curmap);
      fillpalletedata();
   }

//this selects a structure from the map screen
   if((mouse_y > 220) && (mouse_x > 192) && (mouse_x < 192+256)){
      curstructure = romdata[dataoffset+0xf10+(romdata[0xa10+dataoffset+curmap]*0x40)+
      (((mouse_y-220)/32)*8)+((mouse_x-192)/32)];
   }

//this code draws a tile onto a structure
  if((mouse_x-128 < 32) && (mouse_y-160 < 32) &&
  (mouse_y-160 > 0) && (mouse_x-128 > 0)){
  
  if((mouse_y-160 < 16) && (mouse_x-128 < 16))
  curblock=romdata[0x1710+dataoffset+(curstructure*4)];

  if((mouse_y-160 < 16) && (mouse_x-128 > 16))
  curblock=romdata[0x1710+dataoffset+(curstructure*4)+1];

  if((mouse_y-160 > 16) && (mouse_x-128 < 16))
  curblock=romdata[0x1710+dataoffset+(curstructure*4)+2];

  if((mouse_y-160 > 16) && (mouse_x-128 > 16))
  curblock=romdata[0x1710+dataoffset+(curstructure*4)+3];

  fillstructuredata();
  fillmapdata(curmap);
  }

//this code changes command if you clicked it
  if((mouse_y > 64) && (mouse_y < 72)){
    if((mouse_x > 130) && (mouse_x < 234)){
    command--;
    }
  }

//this code changes command if you clicked it
  if((mouse_y > 72) && (mouse_y < 80)){
    if((mouse_x > 130) && (mouse_x < 280)){
    romdata[0xa50+dataoffset+command] =
    ((romdata[0xa50+dataoffset+command]+1)&15)+
    ((romdata[0xa50+dataoffset+command]>>4)<<4);
    }
  }

//this code changes screen chr data
  if((mouse_y > 88) && (mouse_y < 96)){
    if((mouse_x > 130) && (mouse_x < 272)){
    romdata[0xa70+dataoffset+(command*2)] =
    ((romdata[0xa70+dataoffset+(command*2)]+1)&15)+
    (((romdata[0xa70+dataoffset+(command*2)]>>4))<<4);
    }
  }

}//end if mouse button 2 is clicked

//this code makes command where it never gets too big
command&=15;

//Now after finishing the clicking code. This is the key press code

//this makes LSHIFT give you a useful turbo click feature
if(key[KEY_LSHIFT]){canclick1 = true; canclick2 = true;}

//p changes palletes
if(key[KEY_P]){
   key[KEY_P] = 0;
   palletenumber = ((palletenumber+1)&3);
   loadpallete();
   filltiledata();
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
}

//x and y change blocks
if(key[KEY_X]){
   curblock++;
   key[KEY_X] = 0;
}
if(key[KEY_Z]){
   curblock--;
   key[KEY_Z] = 0;
}

//a and s changes structures
if(key[KEY_A]){
   curstructure--;
   key[KEY_A] = 0;
}
if(key[KEY_S]){
   curstructure++;
   key[KEY_S] = 0;
}

//left and right changes map screens
if(key[KEY_LEFT]){
   key[KEY_LEFT] = 0;
   if(curmap > 0)fillmapdata(--curmap);
}
if(key[KEY_RIGHT]){
   key[KEY_RIGHT] = 0;
   if(curmap < 63)fillmapdata(++curmap);
}

//Q and W changes palletes (for the tiles)
if(key[KEY_Q]){
   key[KEY_Q] = 0;
   if(currentpal > 0)currentpal--;
filltiledata();
}

if(key[KEY_W]){
   key[KEY_W] = 0;
   if(currentpal < 3)currentpal++;
filltiledata();
}

//e and r changes levels
if(key[KEY_E]){
   key[KEY_E] = 0;
   if(level > 0)level+=99;
   }

if(key[KEY_R]){
   key[KEY_R] = 0;
   if(level < 18)level+=101; //adding 100 extra will allow us to check later on if we need
                             //to update the screen
   }

if(level > 90){ //if we need to update the level
level-=100;

   switch(level){
   case 0 : {dataoffset = 0; chroffset = 0x52010; break;}
   case 1 : {dataoffset = 0x2000; chroffset = 0x51010; break;}
   case 2 : {dataoffset = 0x4000; chroffset = 0x53010; break;}
   case 3 : {dataoffset = 0x6000; chroffset = 0x54010; break;}
   case 4 : {dataoffset = 0x8000; chroffset = 0x56010; break;}
   case 5 : {dataoffset = 0xa000; chroffset = 0x50010; break;}
   case 6 : {dataoffset = 0xc000; chroffset = 0x55010; break;}
   case 7 : {dataoffset = 0xe000; chroffset = 0x57010; break;}
   case 8 : {dataoffset = 0x10000; chroffset = 0x52010; break;}
   case 9 : {dataoffset = 0x12000; chroffset = 0x53010; break;}
   case 10 : {dataoffset = 0x14000; chroffset = 0x55010; break;}
   case 11 : {dataoffset = 0x16000; chroffset = 0x57010; break;}
   case 12 : {dataoffset = 0x18000; chroffset = 0x58010; break;}
   case 13 : {dataoffset = 0x1a000; chroffset = 0x59010; break;}
   case 14 : {dataoffset = 0x1e000; chroffset = 0x58010; break;}
   case 15 : {dataoffset = 0x22000; chroffset = 0x59010; break;}
   case 16 : {dataoffset = 0x1c000; chroffset = 0x5c010; break;}
   case 17 : {dataoffset = 0x20000; chroffset = 0x5e010; break;}
   case 18 : {dataoffset = 0x26000; chroffset = 0x5d010; break;}
   }

   copytiles(chroffset);
   loadpallete();
   filltiledata();
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   fillpalletedata();
}

//D and F changes chr offsets
if(key[KEY_D]){
   key[KEY_D] = 0;
   if(chroffset > 0x40010)chroffset-=0x1000;else chroffset=0x40010;
   copytiles(chroffset);
   loadpallete();
   filltiledata();
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   fillpalletedata();
}

if(key[KEY_F]){
   key[KEY_F] = 0;
   if(chroffset < 0x5F010)chroffset+=0x1000;else chroffset=0x5F010;
   copytiles(chroffset);
   loadpallete();
   filltiledata();
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   fillpalletedata();
}

//space enables/disables spritemode
if(key[KEY_SPACE]){
   key[KEY_SPACE] = 0;
   spritemode = !spritemode;
   fillmapdata(curmap);
}

//1, 2, 3, 4, 5, 6, 7, 8, 9, and 0 changes differient sprite properties
if(key[KEY_1]){
   key[KEY_1] = 0;
   cursprite--;
   fillmapdata(curmap);
}

if(key[KEY_2]){
   key[KEY_2] = 0;
   cursprite++;
   fillmapdata(curmap);
}

if(key[KEY_3]){
   key[KEY_3] = 0;
   romdata[cursprite+dataoffset+0xc10]--;
   fillmapdata(curmap);
}

if(key[KEY_4]){
   key[KEY_4] = 0;
   romdata[cursprite+dataoffset+0xc10]++;
   fillmapdata(curmap);
}

if(key[KEY_5]){
   key[KEY_5] = 0;
   romdata[cursprite+dataoffset+0xd10]--;
   fillmapdata(curmap);
}

if(key[KEY_6]){
   key[KEY_6] = 0;
   romdata[cursprite+dataoffset+0xd10]++;
   fillmapdata(curmap);
}

if(key[KEY_7]){
   key[KEY_7] = 0;
   romdata[cursprite+dataoffset+0xb10]--;
   fillmapdata(curmap);
}

if(key[KEY_8]){
   key[KEY_8] = 0;
   romdata[cursprite+dataoffset+0xb10]++;
   fillmapdata(curmap);
}

if(key[KEY_9]){
   key[KEY_9] = 0;
   romdata[cursprite+dataoffset+0xe10]--;
   fillmapdata(curmap);
}

if(key[KEY_0]){
   key[KEY_0] = 0;
   romdata[cursprite+dataoffset+0xe10]++;
   fillmapdata(curmap);
}

//this is the sprite insert code
if((clicked1) && (key[KEY_INSERT]) &&
   (mouse_x > 192) && (mouse_y < 192+256) &&
   (mouse_y > 220)){
insert_sprite(curmap,mouse_x-184,mouse_y-220);
fillmapdata(curmap);
}

//and sprite delete code
if(key[KEY_DEL]){
   key[KEY_DEL] = 0;
   delete_sprite();
   fillmapdata(curmap);
} //DEL deletes a sprite

//F2 Takes a PCX snapshot of the editor
if(key[KEY_F2]){
key[KEY_F2] = 0;
if(save_pcx("snapshot.pcx",screenbuff, NULL))crash("error saving pcx");
}

//F4 reloads
if(key[KEY_F4]){
key[KEY_F4] = 0;
if(loadrom())crash("Failed to load Megaman3.nes");
   copytiles(chroffset);
   loadpallete();
   filltiledata();
   fillblockdata();
   fillstructuredata();
   fillmapdata(curmap);
   fillpalletedata();
}

//F5 saves
if(key[KEY_F5]){
key[KEY_F5] = 0;
if(saverom())crash("Failed to save Megaman3.nes");
}


//drawing code
//its messy but oh well
clear(screenbuff);//clear the screenbuffer

//draw all tiles
for(i = 0;i < 256;i++){
draw_sprite(screenbuff,tile[currentpal][i],((i&15)<<3)+1,((i>>4)<<3)+1);
}

//draw all 9 blocks
draw_sprite(screenbuff,block[(curblock-4)&255],0,136);
draw_sprite(screenbuff,block[(curblock-3)&255],16*1,136);
draw_sprite(screenbuff,block[(curblock-2)&255],16*2,136);
draw_sprite(screenbuff,block[(curblock-1)&255],16*3,136);

//this is the center and main block
draw_sprite(screenbuff,block[(curblock)&255],16*4,136);

draw_sprite(screenbuff,block[(curblock+1)&255],16*5,136);
draw_sprite(screenbuff,block[(curblock+2)&255],16*6,136);
draw_sprite(screenbuff,block[(curblock+3)&255],16*7,136);
draw_sprite(screenbuff,block[(curblock+4)&255],16*8,136);

//lets draw a nice rectangle around the center block outlining it.
rect(screenbuff,16*4,136,16*5,152,makecol(255,0,0));

//draw all 9 structures
draw_sprite(screenbuff,structure[(curstructure-4)&255],0,160);
draw_sprite(screenbuff,structure[(curstructure-3)&255],32*1,160);
draw_sprite(screenbuff,structure[(curstructure-2)&255],32*2,160);
draw_sprite(screenbuff,structure[(curstructure-1)&255],32*3,160);
//this is the center and main block
draw_sprite(screenbuff,structure[curstructure],32*4,160);

draw_sprite(screenbuff,structure[(curstructure+1)&255],32*5,160);
draw_sprite(screenbuff,structure[(curstructure+2)&255],32*6,160);
draw_sprite(screenbuff,structure[(curstructure+3)&255],32*7,160);
draw_sprite(screenbuff,structure[(curstructure+4)&255],32*8,160);

//lets draw a nice rectangle around the center structure outlining it.
rect(screenbuff,32*4,160,32*5,192,makecol(255,0,0));

//draw 3 screens of map
draw_sprite(screenbuff,map[(curmap-1)&63],192-256,220);
draw_sprite(screenbuff,map[(curmap)&63],192,220);
draw_sprite(screenbuff,map[(curmap+1)&63],192+256,220);

//draw a white rectangle around center main map, just for looks, and fun.
rect(screenbuff,192,219,192+256,220+256,makecol(255,0,0));

//draw the pallete
draw_sprite(screenbuff,levelpal,290,106);

//and draw a white rectangle around the pallete
rect(screenbuff,290,106,290+(16*20),106+(16*4),makecol(255,255,255));

//this prints up the map screen, if its invalid it prints it in red
if(romdata[curmap+dataoffset+0xa10] < 32)
textprintf(screenbuff,font,396,211,makecol(255,255,255),"<    Map Screen %3d  >",
romdata[curmap+dataoffset+0xa10]);
else
textprintf(screenbuff,font,396,211,makecol(255,0,0),"<    Map Screen %3d  >",
romdata[curmap+dataoffset+0xa10]);

textprintf(screenbuff,font,396,203,makecol(255,255,255),"<    LEVEL %5d     >",level);

//draw the text "< CURRENT SPRITE %d >"
textprintf(screenbuff,font,300,56,makecol(255,255,255),"< CURRENT SPRITE %3d >",cursprite);

//draw a rect around the < and > of CURRENT SPRITE
rect(screenbuff,300,56,308,64,makecol(255,255,255));
rect(screenbuff,468,56,474,64,makecol(255,255,255));

//draw the text "<  SPRITE X %d  >"
textprintf(screenbuff,font,300,64,makecol(255,255,255),"<    SPRITE X %3d    >",
romdata[cursprite+dataoffset+0xc10]);

//draw a rect around the < and > of SPRITE X
rect(screenbuff,300,64,308,72,makecol(255,255,255));
rect(screenbuff,468,64,474,72,makecol(255,255,255));

//draw the text "<  SPRITE Y %d  >"
textprintf(screenbuff,font,300,72,makecol(255,255,255),"<    SPRITE Y %3d    >",
romdata[cursprite+dataoffset+0xd10]);

//draw a rect around the < and > of SPRITE Y
rect(screenbuff,300,72,308,80,makecol(255,255,255));
rect(screenbuff,468,72,474,80,makecol(255,255,255));


//draw the text "<  SPRITE SCREEN %d  >"
textprintf(screenbuff,font,300,80,makecol(255,255,255),"<  SPRITE SCREEN %3d >",
romdata[cursprite+dataoffset+0xb10]);

//draw a rect around the < and > of SPRITE SCREEN
rect(screenbuff,300,80,308,88,makecol(255,255,255));
rect(screenbuff,468,80,474,88,makecol(255,255,255));


//draw the text "<  SPRITE TYPE %d  >"
textprintf(screenbuff,font,300,88,makecol(255,255,255),"<  SPRITE TYPE 0x%2x  >",
romdata[cursprite+dataoffset+0xe10]);

//draw a rect around the < and > of SPRITE TYPE
rect(screenbuff,300,88,308,96,makecol(255,255,255));
rect(screenbuff,468,88,474,96,makecol(255,255,255));

//if its a null(255) sprite then it means no more sprites for the level
//print this up if so

if((romdata[cursprite+dataoffset+0xb10] == 255)&&
(romdata[cursprite+dataoffset+0xc10] == 255)&&
(romdata[cursprite+dataoffset+0xd10] == 255)&&
(romdata[cursprite+dataoffset+0xe10] == 255))
textprintf(screenbuff,font,300,96,makecol(255,255,255),"NULL END OF SPRITES");

textprintf(screenbuff,font,130,64,makecol(255,255,255),"COMMAND = %3d",command);

//draw a box around command
rect(screenbuff,130,64,234,72,makecol(255,255,255));

textprintf(screenbuff,font,130,72,makecol(255,255,255),"SCREEN DIRECTION %2x",
romdata[0xa50+dataoffset+command]);
//now draw a box around screen direction
rect(screenbuff,130,72,280,80,makecol(255,255,255));

textprintf(screenbuff,font,130,80,makecol(255,255,255),"SCREEN PALLETE %2x",
romdata[0xa70+dataoffset+(command*2)+1]);
//now draw a box around screen pallete
rect(screenbuff,130,80,264,88,makecol(255,255,255));

textprintf(screenbuff,font,130,88,makecol(255,255,255),"SCREEN CHR DATA %2x",
romdata[0xa70+dataoffset+(command*2)]);
//now draw a box around screen chr data
rect(screenbuff,130,88,272,96,makecol(255,255,255));

textprintf(screenbuff,font,130,97,makecol(255,0,0),"^NOT ALL DECODED YET^");

//textprintf(screenbuff,font,130,80,makecol(255,255,255),"FOR %D SCREENS",
//(romdata[0xa50+dataoffset+command])&15);

textprintf(screenbuff,font,130,0,makecol(255,255,255),"Selected Block = %d   ",curblock);
textprintf(screenbuff,font,130,8,makecol(255,255,255),"Structure = %d  ",curstructure);
textprintf(screenbuff,font,130,16,makecol(255,255,255),"Selected Pallete = %d  ",palletenumber);
textprintf(screenbuff,font,130,24,makecol(255,255,255),"Data Offset = 0x%x",dataoffset);
textprintf(screenbuff,font,130,32,makecol(255,255,255),"Chr Offset = 0x%x",chroffset);
textprintf(screenbuff,font,130,40,makecol(255,255,255),"Mouse Location %d, %d",mouse_x,mouse_y);

textprintf(screenbuff,font,144,136,makecol(255,255,255),"blockpal = 0x%x",
romdata[(0x1f10+dataoffset)+curblock]&15);

textprintf(screenbuff,font,144,144,makecol(255,255,255),"blockdata = 0x%x",
(romdata[(0x1f10+dataoffset)+curblock]>>4)&15);

//display info about the editor
textprintf(screenbuff,font,300,0,makecol(255,255,255),COPYRIGHT_STRING_1);
textprintf(screenbuff,font,300,8,makecol(255,255,255),COPYRIGHT_STRING_2);
textprintf(screenbuff,font,300,16,makecol(255,255,255),COPYRIGHT_STRING_3);
textprintf(screenbuff,font,300,24,makecol(255,255,255),COPYRIGHT_STRING_4);
textprintf(screenbuff,font,300,32,makecol(255,255,255),COPYRIGHT_STRING_5);

//draw a rectangle around the blockpal, and blockdata
rect(screenbuff,232,136,256,144,makecol(255,255,255));
rect(screenbuff,240,144,264,152,makecol(255,255,255));

//draw a rect around all the pattern table data
rect(screenbuff,0,0,129,129,makecol(255,255,255));

//draw a rect around your selected pattern table
rect(screenbuff,((curtile&15)*8)+1,((curtile>>4)*8)+1,(((curtile&15)*8)+7)+1,
(((curtile>>4)*8)+7)+1,makecol(255,255,255));

//draw a rect around the < and > of Level
rect(screenbuff,396,203,404,211,makecol(255,255,255));
rect(screenbuff,564,203,572,211,makecol(255,255,255));

//draw a rect around the < and > of Map screen
rect(screenbuff,396,211,404,219,makecol(255,255,255));
rect(screenbuff,564,211,572,219,makecol(255,255,255));

//and last draw the mouse
masked_blit(cursor,screenbuff,0,0,mouse_x,mouse_y,16,16);

//this is the very last part of the function.
if(key[KEY_ESC]){
   exitf = true;
}

//yay its over
return;
}