//external.h
//contains all the external functions and variables, and defines
//for my map editor

//////Defines//////
#define true 1
#define false 0

//this contains the tiledata structure
typedef union
{
unsigned char byte;
   struct 
   {
      unsigned int b0 : 1;
      unsigned int b1 : 1;
      unsigned int b2 : 1;
      unsigned int b3 : 1;
      unsigned int b4 : 1;
      unsigned int b5 : 1;
      unsigned int b6 : 1;
      unsigned int b7 : 1;
   } bits;
} BITTOBYTE;

//////Variables//////
extern int exitf; //the exit flag
extern BITMAP *screenbuff;
extern int bbp;
extern unsigned char romdata[400000];//actual megaman3.nes
                                     //rom is 393262 bytes
                                     //but this should hold it

//nes pallete data, it is actually initialized in miscfunctions.c
extern int nes_palbase_red[64];
extern int nes_palbase_green[64];
extern int nes_palbase_blue[64];

BITTOBYTE tiledata[4096];
extern int palletecolor[4][4];
extern int dataoffset, chroffset, palletenumber;
extern BITMAP *tile[4][256];
extern BITMAP *levelpal;
extern BITMAP *block[256];
extern BITMAP *structure[256];
extern BITMAP *map[64];
extern int currentpal;
extern int clicked1, clicked2; //the mouse variables
extern int canclick1,canclick2;
extern unsigned char spritemode, cursprite;
extern unsigned char level;

//////Functions//////
extern void init();
extern void uninit();
extern void runeditor();
extern void crash(char *error);
extern int loadrom();
extern int saverom();
extern void copytiles();
extern void filltiledata();
extern void fillblockdata();
extern void fillstructuredata();
extern void fillmapdata(int map);
extern void loadpallete();
extern void fillpalletedata();
extern int getnescolor(int palleteindex);
extern int insert_sprite(unsigned char screen,unsigned char x,unsigned char y);
extern void delete_sprite();