//main.c
//contains the main function

//stdio include
#include <stdio.h>
#include <stdlib.h>

//allegro include
#include <allegro.h>

//external include
#include "external.h"

//variables
int x, y, i;
unsigned char romdata[400000];//actual megaman3.nes
                              //rom is 393262 bytes
                              //but this should hold it
int palletecolor[4][4];
int currentpal;

//this is the nes pallete data

int nes_palbase_red[64] = {
    139,   0,   0,  90, 106, 123, 139, 123, 106,  90,   0,   0,   0,    0,0,0,
    205,  67,  67, 133, 152, 171, 205, 171, 152, 133,  67,  67,  67,    0,0,0,
    238,  90,  90, 154, 182, 210, 238, 210, 182, 154,  90,  90,  90,    0,0,0,
    255, 135, 135, 165, 195, 225, 255, 225, 195, 165, 135, 135, 135,    0,0,0,
};

int nes_palbase_green[64] = {
    139,  90,   0,   0,   0,   0,   0,  90, 106, 123, 139, 123, 106,    0,0,0,
    205, 133,  67,  67,  67,  67,  67, 133, 152, 171, 205, 171, 152,    0,0,0,
    238, 154,  90,  90,  90,  90,  90, 154, 182, 210, 238, 210, 182,    0,0,0,
    255, 165, 135, 135, 135, 135, 135, 165, 195, 225, 255, 225, 195,    0,0,0,
};

int nes_palbase_blue[64] = {
    139, 123, 139, 123, 106,  90,   0,   0,   0,   0,   0,  90, 106,    0,0,0,
    205, 171, 205, 171, 152, 133,  67,  67,  67,  67,  67, 133, 152,    0,0,0,
    238, 210, 238, 210, 182, 154,  90,  90,  90,  90,  90, 154, 182,    0,0,0,
    255, 225, 255, 225, 195, 165, 135, 135, 135, 135, 135, 165, 195,    0,0,0,
};

//functions
//crash(char error[])
//this function basacaly displays the error and exits...
void crash(char *error){
uninit();
printf(error);
exit(1);
}

//loads the rom, returns 1 on error
int loadrom(){
FILE *romfile;
if((romfile = fopen("megaman3.nes", "rb")) == NULL)
return 1;
fread(romdata,393232,1,romfile);
fclose(romfile);
}

//saves the rom, returns 1 on error
int saverom(){
FILE *romfile;
if((romfile = fopen("megaman3.nes", "wb")) == NULL)
return 1;
fwrite(romdata,393232,1,romfile);
fclose(romfile);
}

//copies tiles from the rom to the tiledata struct
void copytiles(int romoffset){

for(i = 0;i < 4096;i++){
tiledata[i].byte = romdata[romoffset+i];
}
//simple eh?
return;
}

//this slow function is what loads all the graphics directly from the rom into a bitmap
void filltiledata(){
int currenttile;

for(currenttile = 0;currenttile < 256;currenttile++){
for(x = 0;x < 8;x++){
for(y = 0;y < 8;y++){
if(x == 7)i = tiledata[(currenttile*16)+y].bits.b0 | (tiledata[(currenttile*16)+y+8].bits.b0<<1);
if(x == 6)i = tiledata[(currenttile*16)+y].bits.b1 | (tiledata[(currenttile*16)+y+8].bits.b1<<1);
if(x == 5)i = tiledata[(currenttile*16)+y].bits.b2 | (tiledata[(currenttile*16)+y+8].bits.b2<<1);
if(x == 4)i = tiledata[(currenttile*16)+y].bits.b3 | (tiledata[(currenttile*16)+y+8].bits.b3<<1);
if(x == 3)i = tiledata[(currenttile*16)+y].bits.b4 | (tiledata[(currenttile*16)+y+8].bits.b4<<1);
if(x == 2)i = tiledata[(currenttile*16)+y].bits.b5 | (tiledata[(currenttile*16)+y+8].bits.b5<<1);
if(x == 1)i = tiledata[(currenttile*16)+y].bits.b6 | (tiledata[(currenttile*16)+y+8].bits.b6<<1);
if(x == 0)i = tiledata[(currenttile*16)+y].bits.b7 | (tiledata[(currenttile*16)+y+8].bits.b7<<1);
putpixel(tile[0][currenttile],x,y,palletecolor[0][i]);
putpixel(tile[1][currenttile],x,y,palletecolor[1][i]);
putpixel(tile[2][currenttile],x,y,palletecolor[2][i]);
putpixel(tile[3][currenttile],x,y,palletecolor[3][i]);
}
}
}

}

//this function fills the block bitmaps with data from the rom
void fillblockdata(){
for(i = 0;i < 256;i++){
draw_sprite(block[i],tile[romdata[(0x1f10+dataoffset)+i]&3][romdata[(0x1b10+dataoffset)+i]],0,0);
draw_sprite(block[i],tile[romdata[(0x1f10+dataoffset)+i]&3][romdata[(0x1c10+dataoffset)+i]],8,0);
draw_sprite(block[i],tile[romdata[(0x1f10+dataoffset)+i]&3][romdata[(0x1d10+dataoffset)+i]],0,8);
draw_sprite(block[i],tile[romdata[(0x1f10+dataoffset)+i]&3][romdata[(0x1e10+dataoffset)+i]],8,8);
}
}

//this fills the structure bitmaps with data from the rom
void fillstructuredata(){
//slowly fills the structure
for(i = 0;i < 256;i++){
draw_sprite(structure[i],block[romdata[(0x1710+dataoffset)+(i*4)]],0,0);
draw_sprite(structure[i],block[romdata[(0x1710+dataoffset)+(i*4)+1]],16,0);
draw_sprite(structure[i],block[romdata[(0x1710+dataoffset)+(i*4)+2]],0,16);
draw_sprite(structure[i],block[romdata[(0x1710+dataoffset)+(i*4)+3]],16,16);
}

}

//fills the map data
void fillmapdata(int maptofill){
for(i = -1;i < 2;i++){

//draw the structures
for(y = 0;y < 8;y++){
for(x = 0;x < 8;x++){
draw_sprite(map[(i+maptofill)&63],structure[
romdata[(0x0f10+dataoffset)+((romdata[(i+maptofill)+dataoffset+0xa10])*0x40)+x+(y*8)]]
,x*32,y*32);
}
}

//draw the sprites
for(x = 0;x < 256;x++){
if(spritemode){
//this breaks the loop when the sprite is 255 (end)
if((romdata[x+dataoffset+0xb10] == 255)&&
(romdata[x+dataoffset+0xc10] == 255)&&
(romdata[x+dataoffset+0xd10] == 255)&&
(romdata[x+dataoffset+0xe10] == 255))break;

if((romdata[dataoffset+0xb10+x]) == (i+maptofill)&63){
textprintf(map[(i+maptofill)&63],font,romdata[0xc10+dataoffset+x]-8,
romdata[0xd10+dataoffset+x],makecol(255,255,255),"%x",romdata[0xe10+dataoffset+x]);

//this prints the sprite in green if its on the wrong screen
if((romdata[dataoffset+0xb10+x] < romdata[dataoffset+0xb10+x-1]) && (x!=0))
textprintf(map[(i+maptofill)&63],font,romdata[0xc10+dataoffset+x]-8,
romdata[0xd10+dataoffset+x],makecol(0,255,0),"%x",romdata[0xe10+dataoffset+x]);

//this prints your currently selected sprite in red
if(x == cursprite)textprintf(map[(i+maptofill)&63],font,romdata[0xc10+dataoffset+x]-8,
romdata[0xd10+dataoffset+x],makecol(255,0,0),"%x",romdata[0xe10+dataoffset+x]);}

}//end if spritemode
}//end the x for loop
}//end the i for loop

//end function
}

//structure[(0x0f10+dataoffset)+(romdata[((i+maptofill)&31)+dataoffset+0xa10]

//*0x40)+x+(y*8)]]

void loadpallete(){

//if(level < 16){
for(x = 0;x < 4;x++)
for(y = 0;y < 4;y++)
palletecolor[y][x] = getnescolor(romdata[(0x0a92+dataoffset)+(palletenumber*20)+(y*4)+x]);
//}

//maybe for future use if I ever implement title screen editing
//if(level == 16)
//for(x = 0;x < 4;x++)
//for(y = 0;y < 4;y++)
//palletecolor[y][x] = getnescolor(romdata[(0x31c13)+(palletenumber*20)+(y*4)+x]);


}

void fillpalletedata(){

for(i = 0;i < 80;i++){
   for(x = 0;x < 16;x++){
      for(y = 0;y < 16;y++){
putpixel(levelpal,x+((i-((i/20)*20))*16),y+((i/20)*16),
getnescolor(romdata[(0xa92+dataoffset)+i]));
      }
   }

//Print up the pallete index number
textprintf(levelpal,font,((i-((i/20)*20))*16),((i/20)*16),makecol(255,255,255),
"%x",romdata[(0xa92+dataoffset)+i]);

rect(levelpal,((i-((i/20)*20))*16),((i/20)*16),((i-((i/20)*20))*16)+16,((i/20)*16)+16
,makecol(255,255,255));

}

return;

}

int getnescolor(int palleteindex){
if(palleteindex > 64)return makecol(0,0,0);
return (makecol(nes_palbase_red[palleteindex],nes_palbase_green[palleteindex]
,nes_palbase_blue[palleteindex]));
}

//this will insert a sprite, it returns the sprite index where it inserted it at
int insert_sprite(unsigned char screen,unsigned char x,unsigned char y){

for(cursprite = 0;cursprite < 256;cursprite++){
if(romdata[cursprite+0xb10+dataoffset] >= screen)break;
}

//yes I used the evil goto, but I think its practical to use it here
//and I need a break since I very rarely EVER use it.
if(romdata[cursprite+0xb10+dataoffset] != screen)goto skip;
if(romdata[cursprite+0xc10+dataoffset] < x)cursprite++;
if(romdata[cursprite+0xb10+dataoffset] != screen)goto skip;
if(romdata[cursprite+0xc10+dataoffset] < x)cursprite++;
if(romdata[cursprite+0xb10+dataoffset] != screen)goto skip;
if(romdata[cursprite+0xc10+dataoffset] < x)cursprite++;
if(romdata[cursprite+0xb10+dataoffset] != screen)goto skip;
if(romdata[cursprite+0xc10+dataoffset] < x)cursprite++;
skip:

for(i = 254;i > 0;i--){
romdata[0xb10+dataoffset+i+1] = romdata[0xb10+dataoffset+i];
romdata[0xc10+dataoffset+i+1] = romdata[0xc10+dataoffset+i];
romdata[0xd10+dataoffset+i+1] = romdata[0xd10+dataoffset+i];
romdata[0xe10+dataoffset+i+1] = romdata[0xe10+dataoffset+i];
if(i == cursprite)break;
}

romdata[0xb10+dataoffset+cursprite] = screen;
romdata[0xc10+dataoffset+cursprite] = x;
romdata[0xd10+dataoffset+cursprite] = y;
romdata[0xe10+dataoffset+cursprite] = romdata[0xe10+dataoffset+cursprite+1];

return cursprite;

}

//deletes cursprite
void delete_sprite(){

for(i = cursprite;i < 255;i++){
romdata[0xb10+dataoffset+i] = romdata[0xb10+dataoffset+i+1];
romdata[0xc10+dataoffset+i] = romdata[0xc10+dataoffset+i+1];
romdata[0xd10+dataoffset+i] = romdata[0xd10+dataoffset+i+1];
romdata[0xe10+dataoffset+i] = romdata[0xe10+dataoffset+i+1];
}

}